UIReloadFu = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "AceEvent-2.0")
UIReloadFu:RegisterDB("UIReloadFuDB")
UIReloadFu.hasIcon = "Interface\\Icons\\Ability_Mount_Dreadsteed"
UIReloadFu.hideMenuTitle = true
--UIReloadFu.hasNoText = true
UIReloadFu.clickableTooltip = true
UIReloadFu.defaultPosition = "CENTER"
UIReloadFu.countDown = 0

local Tablet = AceLibrary("Tablet-2.0")
local L = AceLibrary("AceLocale-2.2"):new("FuBar_UIReloadFu")
StaticPopupDialogs["UIRELOADFUCONFIRM"] = { } -- text = "Do you really want to Reload the User Interface?\n\nSome changes may get lost!", button1 = "Yes", button2 = "No", timeout = 0, whileDead = 1, OnAccept = function() UIReloadFu:DoReload() end}

function UIReloadFu:OnEnable()
	self:Print(L["translator"])
end

UIReloadFu.OnMenuRequest = {
	type = 'group',
	args = {
		header = {
			type = "header",
			name = L["addonname"],
			icon = UIReloadFu.hasIcon,
			iconHeight = 16,
			iconWidth = 16,
			order = 1
		},
	},
}

function UIReloadFu:OnClick()
	self:Confirm(L["ReloadUI_confirm"], function() ReloadUI() end)
end

function UIReloadFu:OnTextUpdate()
	self:SetText(L["addonnameFu"])
end

function UIReloadFu:StartCountDown()
	if (self:IsEventScheduled("DoCountDown")) then return end
	UIReloadFu.countDown = 20
	self:ScheduleRepeatingEvent("DoCountDown", self.DoCountDown, 1, self)
end

function UIReloadFu:DoCountDown()
	local receiver = "RAID_WARNING"
	local message = "Going in "..UIReloadFu.countDown.." sec"
	if ((not IsRaidLeader()) and (not IsRaidLeader())) then receiver = "RAID" end
	
	if (UIReloadFu.countDown == 20) then
		UIReloadFu:SendChatMessage(message, receiver)
	elseif (UIReloadFu.countDown == 15) then
		UIReloadFu:SendChatMessage(message, receiver)
	elseif ((UIReloadFu.countDown < 6) and (UIReloadFu.countDown > 0)) then
		UIReloadFu:SendChatMessage(message, receiver)
	elseif (UIReloadFu.countDown == 0) then
		UIReloadFu:SendChatMessage("---> Go Go Go <---", receiver)
		self:CancelScheduledEvent("DoCountDown")
	end
	UIReloadFu.countDown = UIReloadFu.countDown - 1
end

function UIReloadFu:StopCountDown()
	self:CancelScheduledEvent("DoCountDown")
end

function UIReloadFu:SendChatMessage(message, receiver)
	if (self.debugging) then
		self:Print(message)
	else
		SendChatMessage(message, receiver)
	end
end

function UIReloadFu:Confirm(text, onAccept, timeout, whileDead)
	if (not timeout) then timeout = 0 end
	if (not whileDead) then whileDead = 1 end
	
	StaticPopupDialogs["UIRELOADFUCONFIRM"].text = text
	StaticPopupDialogs["UIRELOADFUCONFIRM"].button1 = L["Yes"]
	StaticPopupDialogs["UIRELOADFUCONFIRM"].button2 = L["No"]
	StaticPopupDialogs["UIRELOADFUCONFIRM"].timeout = timeout
	StaticPopupDialogs["UIRELOADFUCONFIRM"].whileDead = whileDead
	StaticPopupDialogs["UIRELOADFUCONFIRM"].OnAccept = onAccept
	StaticPopup_Show("UIRELOADFUCONFIRM")
end

function UIReloadFu:OnTooltipUpdate()
	cat = Tablet:AddCategory(
  	'columns', 1
  )
  
  cat:AddLine(
    'text', " "
  )
  
  cat:AddLine(
    'text', L["ReloadUI"],
    'func', function() UIReloadFu:Confirm(L["ReloadUI_confirm"], function() ReloadUI() end) end,
    'justify', "CENTER"
  )
  
  cat:AddLine(
    'text', " "
  )
  
  cat:AddLine(
  	'text', L["LeaveParty"],
    'func', function() UIReloadFu:Confirm(L["LeaveParty_confirm"], function() LeaveParty() end) end,
    'justify', "CENTER"
  )
  
  cat:AddLine(
    'text', " "
  )
  
  if (self:IsEventScheduled("DoCountDown")) then
  	cat:AddLine(
	  	'text', L["SCountdown"],
	    'func', function() UIReloadFu:Confirm(L["SCountdown_confirm"], function() UIReloadFu:StopCountDown() end) end,
	    'justify', "CENTER"
	  )
  else
	  cat:AddLine(
	  	'text', L["Countdown"],
	    'func', function() UIReloadFu:Confirm(L["Countdown_confirm"], function() UIReloadFu:StartCountDown() end) end,
	    'justify', "CENTER"
	  )
  end
    
  Tablet:SetHint(L["FuBarHint"])
end